#include "asgener.h"

FileVersion(asclose.c 4.3 96/03/18)

AsMethod(close)
{
    AsMethodObjPtr(pxSelf);

    FSint ii;
    
    fgsStartMethod(close);
    
    /*== now close the file and release memory ==*/
    
    if(AsIsDbClosed(pxSelf)) goto ok_out;

	fgsDetachVar(&AsForBlock(pxSelf));
	fgsDetachVar(&AsWhileBlock(pxSelf));
	
    /*== tell FS that fields are not needed any more ==*/
	for(ii = 0; (FSulong)ii<AsFCount(pxSelf); ii++)
	{
		if(AsFType(pxSelf,ii) == 'M') Mfree(VAR_CHR(AsFldVar(pxSelf)[ii]));
		
		fgsRetireField(argv[0],AsFName(pxSelf,ii));
	}

    /*== free the variable connecting structures ==*/
    if(AsFldVar(pxSelf))     Mfree(AsFldVar(pxSelf));
    if(AsFldUpdated(pxSelf)) Mfree(AsFldUpdated(pxSelf));
    
    /*== close dbf and correspoding dbt ==*/
    if(AsFh(pxSelf) != 0) fclose_fil(AsFh(pxSelf));
       
    /*== free the allocated buffers ==*/       
    if(AsRecord(pxSelf))   Mfree(AsRecord(pxSelf));
    if(AsBuffer(pxSelf))   Mfree(AsBuffer(pxSelf));
    
    /*== clean up remaining flags ==*/
	asClearObject(argv[0]);
	
    /*== leave a trace that a file had once been opened here ==*/
    AsDbStatus(pxSelf) = DBF_CLOSED;
    
    fgsRetireAlias(argv[0]);
    
 ok_out:
    return fgsEndMethod(TRUE_VAR);
}
/* EOF asclose.c */
