#include "asgener.h"

FileVersion(asfldget.c 4.4 96/02/27)

#if defined(FGSICL600)
#   define FGSICLPRINTFSTR  "%*.*f"
#else
#   define FGSICLPRINTFSTR  "%*.*lf"
#endif


FSvar * asSelfFieldGet(ovSelf, vTmp)
FSvar * ovSelf;
FSvar * vTmp;
{   
    FSchar     tmp[64];
    FSlong     blok;
    FSint      ii       = VAR_ISFLDPOS(vTmp) - 1;
    
    AsAcMetObjPtr(pxSelf);

    if(AsFldUpdated(pxSelf)[ii]) return vTmp;

    AsFldUpdated(pxSelf)[ii] = 1;
    
    switch(AsFType(pxSelf, ii))
    {
    case 'C':
		VAR_CHR(vTmp) = AsField(pxSelf, ii);
        break;
    case 'F':
    case 'N':
        VAR_NUM(vTmp) = msf_atof1((FSchar *) AsField(pxSelf, ii),
								  0, AsFLen(pxSelf,ii));
        break;
    case 'D':
        memcpy(tmp, AsField(pxSelf, ii), AsFLen(pxSelf, ii));
        tmp[AsFLen(pxSelf, ii)] = 0;
        VAR_DATE(vTmp) = get_dat(tmp); /* convert date to  int */
        break;
    case 'L':
        VAR_LOG(vTmp) = *(AsField(pxSelf, ii)) == 'T';
        break;
    default:
        rt_error (DTILLFL, "Unknown field type in ascirdd:fieldget()");
    }
    return vTmp;
}


AsMethod(quickfieldget)
{   
    return asSelfFieldGet(argv[0], argv[1]);
}


/*
 *  xx:FieldGet(nFieldNumber)
 */

AsMethod(fieldget)
{
    AsMethodObjPtr(pxSelf);
    
    FSint      fi;
    
    fgsStartMethod(fieldget);
    
	if(!ISNUMARG(1) && !ISCHRARG(1))
	{
		rt_error(RTILLTYP, "field name or number required");
		return fgsEndMethod(NIL_VAR);
	}
	
	switch(VAR_ISTYPE(argv[1]))
	{
	case 'C':
		argv[1] = AsMeName(fieldpos)(2, argv);
		/*FALLTHRU*/

	case 'N':
	case 'F': fi = VAR_INTNUM(argv[1]) - 1; break;
		
	case 'I': fi = VAR_INT(argv[1]) - 1;    break;
	}
			 
    if((fi < 0) || (fi >= (FSint) AsFCount(pxSelf))) goto error_out;
    argv[1] = AsFldVar(pxSelf)[fi];
    
    return fgsEndMethod(AsMeName(quickfieldget)(2, argv));

 error_out:
    return fgsEndMethod(NIL_VAR);
}
/* EOF asfldget.c */
