*ͻ
* Stand alone demo for the windowing system                                 
*ͼ

#ifndef FS240_DEFINED
#include "fs240.fh"
#endif

private wins[20]

*Ŀ
* First lets create some Windows   
*
setcolor("R+/B")
jj = 1
setclearb("")
for ii = 2 to 16 step 2       
   top    = ii / 2 
   left   = ii 
   bottom = min(top + max(ii, 2), max_row())
   right  = left + ii * 3 
   wins[jj] = wopen(top, left, bottom, right)
   jj = jj + 1
   wbox(0)
next
wformat(3,2,3,2)
@ 0,9 say " ********* ********* ********** "
@ 1,8 say " *         *                  * "
@ 2,7 say " *         *                  * " 
@ 3,6 say " *         *                  * "
@ 4,5 say " ******    ********* ********** "
@ 5,4 say " *                 * *          "
@ 6,3 say " *                 * *          "
@ 7,2 say " *                 * *          "
@ 8,1 say " *     ************* ********** "
inkey(5)

setclearb(" ")
*Ŀ
* now lets open a lot of windows   
*
jj = 0
firstwin = 0
maxwin = 0
status =  wopen(0,0, 2, 60)                 
setcolor("W+/B")
wbox()
do while .T.
    high = min(max(4, int(rand() * 10)), 10)
	wide = min(max(7, int(rand() * 20)), 20)
	top  = max(0, rand() * max_row() - high)
	left = max(0, rand() * max_col() - wide)
	right = left + wide 
	bottom = top + high
	xx= wopen(top, left, bottom, right)
	if firstwin == 0
		firstwin = xx
    endif
	if xx > maxwin
		maxwin = xx
    endif
    if (xx == -1)
	   exit
    endif
    do colors with jj
	jj = jj + 1
	bb = jj % 8
	if bb >= 4
	   bb = bb + 4
    endif
	wbox(bb)       
	@ 0,0 say "W:" + str(xx, 3)
	@ 1,0 say "At" + str(wrow(), 3)
	@ 2,0 say " /" + str(wcol(), 3)
    wselect(status)
 	@ 0, 1 say "Window No.:" + str(xx, 3)  + " "
	inkey()
	if jj > 200 .or. lastkey() = 27
exit
	endif
enddo

*Ŀ
* select a view windows            
*
for ii = firstwin to maxwin
    wselect (ii)
    wselect(status)
	@ 0, 0 say "Select Window No.:" + str(ii) + " "
	inkey()
    if (lastkey() = 27)
exit
    endif
next
setlastkey(1)
*Ŀ
* and close them all again         
*
for ii = maxwin to firstwin step -1
   wselect(ii)
   wclose()
   wselect(status)
   @ 0, 0 say "Close Window No.:" + str(ii) + " "
	inkey()
    if (lastkey() = 27)
exit
    endif
next
inkey(2)
*Ŀ
* now you can move a scrolling win 
*
wselect(status)
@ 0, 0 say "move with CURSOR, write area with S/B, ESCAPE to stop"

wopen (10,15, maxrow(.t.) -10, maxcol(.t.) - 15)
setcolor("GR+/B, GR+/B*")
wbox()
clear screen
formboard = 0
l_maxcol := maxcol() - 28
do while .t.
  if nextkey() != 0
	 x = inkey()
     do case 
     case x = 4
		wmoveright()
     case x = 5
		wmoveup()
     case x = 19
		wmoveleft()
     case x = 24
		wmovedown()
     case x = 115    && 's'
		if (2 * formboard + 2) < l_maxcol
			formboard++
			clear screen
			wformat(0,1,0,1)	
		endif
     case x = 98     && 'b'
		if formboard > 0
			formboard--
			clear screen
			wformat(0,-1,0,-1)	
		endif
     case x = 27
		exit
     endcase
   endif
   ? "This is Outputline: ", str(jj,5)
   jj = jj + 1 

enddo
*Ŀ
* A standing Window is much easier 
*
ksetscroll(.T.)
dummy = "Now again move with the Cursor"
@ 0,0 get dummy
read
ksetscroll(.F.)
*Ŀ
* Thats all Folks                  
*
waclose()
wselect(0)
clear screen
? "Bye Bye"
return

*Ŀ
* procedure colors         sets colors according to a counter (permuted) 
* parameter: numeric counter                                             
*
procedure colors
parameters val
col1 = val % 14
col2 = val / 14
col2 = col2 % 8
col1 = col1 + 1
col2 = col2 + 1

col1 = int(col1)
col2 = int(col2)

do case
case col1 = 1 .or. col1 = 8
	x1 = "B"
case col1 = 2 .or. col1 = 9
	x1 = "G"
case col1 = 3 .or. col1 = 10
	x1 = "BG"
case col1 = 4 .or. col1 = 11
	x1 = "R"
case col1 = 5 .or. col1 = 12
	x1 = "RB"
case col1 = 6 .or. col1 = 13
	x1 = "GR"
case col1 = 7 .or. col1 = 14
	x1 = "W"
endcase
if col1 > 7
	x1 = x1 + "+"
endif
do case
case col2 = 1 
	x2 = "B"
case col2 = 2
	x2 = "G"
case col2 = 3
	x2 = "BG"
case col2 = 4
	x2 = "R"
case col2 = 5
	x2 = "RB"
case col2 = 6
	x2 = "GR"
case col2 = 7
	x2 = "N"
case col2 = 8
	x2 = "W"
endcase
if (x1 == x2) 
  x1 = "W+"
endif
setcolor(x1 + "/" + x2)
return
