****************
* __dispstru(PRINTER)
* 
* funcion definida para compatibilizar:
* hacia : DISPLAY STRUCTURE      Fox command
* desde : dbstruct()             Clipper function
* parametros:
* PRINTER => .T.                 Direcciona a printer
*******************
#include "dbstruct.fh"
func __dispstru(PRINTER)
Local dbfstru, Total:=0
if !used()
   ? "No database in use."
   return
endif
if PRINTER
   set device to printer
   set printer on
endif
dbfstru :=dbstruct()
// print heading hear
Qout ('Structure for Database: ',alias())
Qout ('Number of data records: ',Lastrec())
Qout ('Field Field Name    Type       Width    Dec')
//
// print list hear
for i=1 to len(dbfstru)
    do case
       case dbfstru[i,DBS_TYPE] == "C"
            dbfstru[i,DBS_TYPE] := "Character"
       case dbfstru[i,DBS_TYPE] == "N"
            dbfstru[i,DBS_TYPE] := "Numeric  "
       case dbfstru[i,DBS_TYPE] == "D"
            dbfstru[i,DBS_TYPE] := "Date     "
       case dbfstru[i,DBS_TYPE] == "M"
            dbfstru[i,DBS_TYPE] := "Memo     "
       case dbfstru[i,DBS_TYPE] == "L"
            dbfstru[i,DBS_TYPE] := "Logical  "
    endcase
    ?  padl(i,3)
    ?? space(3)+padr(dbfstru[i,DBS_NAME],10)
    ?? dbfstru[i,DBS_TYPE]
    ?? dbfstru[i,DBS_LEN]
    ?? dbfstru[i,DBS_DEC]
    Total:=Total+dbfstru[i,DBS_LEN]
next
//
// print footing hear
? '** Total **               '
?? Total
if PRINTER
   set device to screen
   set printer to
endif
return
** eof **

