****************************************
* __Ffsys.prg
* SYS functions
*************************
#include "directry.fh"

function sys(Number,a,b,c,d)
Private Date, Numeric, String,String1, String2,Array
Local Retval:=""

#Cinline
{
#include "FSopenc.h"
#include "string.h"
#include "set.fh"

extern variable *_bb_netname();
extern variable *_bb_seconds();
extern variable *_bb_curdir();
extern variable *_bb_set();
extern variable *_bb_version();
extern variable *_bb_os();
extern variable *_bb_procname();
extern variable *_bb_indexord();
extern variable *_bb_readvar();
extern variable *_bb_diskspace();

int sysval=0;
variable          *Fretval=VAR_NEW;
variable          *argv[1];
                                      /* pointer to Flagship retval */
unsigned char     *Cretval;           /* C string */
double             Iretval;           /* C int    */
Fretval=NULLSTR_VAR;
sysval= (int) VAR_NUM(VAR_NAME_LOCPAR(number));

switch(sysval) {
 case 0:
      Fretval=_bb_netname(0,0);
      break;
 case 2:
      Fretval=_bb_seconds(0,0);
      break;
 case 5:case 2004:case 2003:
      Fretval=_bb_curdir(0,0);
      break;
 case 6:
      VAR_NEW_ARGS(argv,1);
      SET_VAR_NUM (argv[0],24.0);
      Fretval=_bb_set(1,argv);    /* SET PRINTFILE */
      break;
 case 9:
      Fretval=_bb_version(0,0);
      break;
 case 16:
      VAR_NEW_ARGS(argv,1);
      SET_VAR_NUM (argv[0],VAR_NUM(VAR_NAME_LOCPAR(a)));
      Fretval=_bb_procname(1,argv);
      break;
     
 case 17:
      Fretval=_bb_os(0,0);
      break;
 case 18:
      Fretval=_bb_readvar(0,0);
      break;
 case 21:
      Fretval=_bb_indexord(0,0);
      break;
 case 101:
      VAR_NEW_ARGS(argv,1);
      SET_VAR_NUM (argv[0],20.0);     /* SET DEVICE */
      Fretval=_bb_set(1,argv);
      break;
 case 2020:
      Fretval=_bb_diskspace(0,0);
      break;
}

if (IS_VAR_CHR(Fretval)) {
              Cretval=VAR_CHR(Fretval);
              SET_VAR_CHR(VAR_NAME_LOCAL(retval),Cretval);}
else {
              Iretval=VAR_NUM(Fretval);
              SET_VAR_NUM(VAR_NAME_LOCAL(retval),Iretval);
                         }
VAR_DELETE;
}
#endCinline


do case
   case Number == 3
        string:=dtoc(date())
        string:=left(string,2)+substr(string,4,2)+substr(string,7,2)
        string1:=time()
        string1:=left(string1,2)+substr(string1,4,2)+substr(string1,7,2)
        string2:=FS_SET("printfile")
        string2:=substr(string2,rat(".",string2))
        return(string+string1+string2)
   case Number == 12
        return ("")
   case Number == 13
        return ("READY")
   case Number == 22
        if valtype(a) =="N"
           b:=alias(a)
           Array:=b->(indexnames())
        else
           Array:=indexnames()
        endif
        if len(Array)< 1
           return ("")
        else
           return (Array[1])
        endif
   case Number == 100
        return (if(set(_SET_CONSOLE),"ON","OFF"))
   case Number == 102
        return (if(set(_SET_PRINTER),"ON","OFF"))
   case Number == 103
        return ("OFF")
   case Number == 2000
        Array:=directory(a)
        if !Empty(b)
            return(Array[2,1])
        else
            return(Array[1,1])
        endif
   case Number == 2002
        if isdigit(a)
           set cursor on
        else
           set cursor off
        endif
        return("")
   case Number == 2006
        return(if(iscolor(),"COLOR DISPLAY","MONOCHROME DISPLAY"))
   case Number == 2015
        string1:=time()
        string1:=left(string1,2)+substr(string1,4,2)+substr(string1,7,2)
        string2:=FS_SET("printfile")
        string2:=substr(string2,rat(".",string2,2))
        return("_"+string1+string2)
   case Number == 2017
        *cls
        return("")
endcase

        
if valtype(retval) # "C"
   retval=str(retval)
endif
Return retval
