**********************
* String functions
* __Fstring.prg
*************
* atc(<caracter exp1>, <caracter exp2> [,<numeric expresion>])
*
* parameters:
*            <caracter exp1>    string to search for
*            <caracter exp2>    string to search in
*            <numeric expresion> ==> occurrence iteration        
* reT: numeric value (position of exp2 in exp1)
* Hint: invierto el string de manera que el rastreo se haga al reves
*********************************************************************

function atc(exp1,exp2,num)
Local count:=1,String:="", pos:=0

for i=len(exp1) to 1 step -1
    String:=String+substr(exp1,i,1)
    count++
next
if pcount() == 3 
   num:=num
else
   num:=1
endif
for i=1 to num
    pos:=at(String,exp2)
    String:=right(String,len(String-pos+1))
next
return pos
**************
* between(exp1,exp2,exp3)
***************************
function between(exp1,exp2,exp3)

if exp1>=exp2 .and. exp1<=exp3
   return .t.
else
   return .f.
endif 
return .f.
**************
* chrsaw(time exp)
**********************
function chrsaw(time)

if pcount() == 0
   time:=0
endif
do while time > 0
   if Lastkey() # 0
      return .t.
   endif
   time:=time-.1
enddo
return .f.
********************
* chrtran(exp1,exp2,tabla)
**********************
function chrtran(exp1,exp2,tabla)
private source, find, target:=""
if pcount() # 3
   return exp1
endif
for i=1 to len(exp1)
    source:=substr(exp1,i,1)
    find:=at(source,exp2)
    if find # 0
       target:=target+substr(tabla,find,1)
    else
       target:=target+source
    endif
next
return (target)
*******************
* difference(exp1,exp2)
**************************
function difference(exp1,exp2)
private rate:=0, valor:=0

if pcount()#2
   return 0
endif
exp1:=soundex(exp1)
exp2:=soundex(exp2)
if exp1 == "0000" .or. exp2 == "0000"
   return 0
endif
// se aplicara un gradiente de valuacion de ocurrencias
// en funcion del retorno de soundex() para cada expresion.
// rate dara la tasa de similitus fonetica.
if left(exp1,1) == left(exp2,1)
   rate:= 2
endif
// para la segunda ocurrencia ==>  rate = (9-valor)/9 *1
// donde valor es la diferencia absoluta de los digitos homologos
valor:=abs(val(substr(exp1,2,1))-val(substr(exp2,2,1)))
   rate:=rate+(9-valor)/9
// para la tercera ocurrencia ==>  rate = (9-valor)/9 *.5
// donde valor es la diferencia absoluta de los digitos homologos
valor:=abs(val(substr(exp1,3,1))-val(substr(exp2,3,1)))

   rate:=rate+((9-valor)/9)*.5
// para la cuarta  ocurrencia ==>  rate = (9-valor)/9 *.25
// donde valor es la diferencia absoluta de los digitos homologos
valor:=abs(val(substr(exp1,4,1))-val(substr(exp2,4,1)))

   rate:=rate+((9-valor)/9)*.25
return (round(rate,0))

****************
* evaluate(exp1)
**********************
function evaluate(exp1)
return type(&exp1)
*******************
* dmy(<date expressiom>)
* Ret: String dd-month-yyyy
************************
function dmy(datv)
return (str(day(datv))+"-"+cmonth(datv)+"-"+str(year(datv)))

*******************
* mdy(<date expressiom>)
* Ret: String month-dd-yyyy
************************
function mdy(datv)
return (cmonth(datv)+"-"+str(day(datv)+"-"+str(year(datv))))

********************
* gomonth(<date>,num)
*********************
function gomonth(datv,num)
Return (datv+month(datv))
