/*

UPDATES A DATA FILE AND RETURNS RESULTS

$Id: example2.prg,v 1.1 1997/09/26 01:47:52 catfood Exp $

WebKit: CGI and FastCGI interface library for FlagShip
Copyright (C) 1996,1997   Mark W. Schumann <webkit@underflap.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$Log: example2.prg,v $
Revision 1.1  1997/09/26 01:47:52  catfood
Initial revision


*/

function example2 (aEnv, aForm)
local i as numeric
local a as array

wkhtml ("Benny's Clip-O-Rama Registration")
wkbody()
wkline ("Thank you for registering at Benny's Clip-O-Rama!")
regform (aForm)
wkbodyend()
wkhtmlend()
return nil

function regform (aForm)
local cFirstname   as string
local cMiddlename  as string
local cLastname    as string
local cUserID      as string
local nUserID      as numeric
local nUserLen     as numeric
field userid IN user
field firstname IN user
field middlename IN user
field lastname IN user

cFirstname  := wklookup (aForm, "FIRSTNAME")
cMiddlename := wklookup (aForm, "MIDDLENAME")
cLastname   := wklookup (aForm, "LASTNAME")

wkline ("Current directory is " + curdir())

//
//    It is a little wasteful to index every time,
//    but this _is_ just an example.
//
use user exclusive
index on user->userid to user1
close

use user index user1
goto bottom
nUserID := val (user->userid)
nUserLen := len (user->userid)
cUserID := str (nUserID + 1, nUserLen, 0)
append blank
user->firstname := cFirstName
user->middlename := cMiddleName
user->lastname := cLastName
user->userid := cUserID
close

wkline ("You have been registered as user <EM>" + cUserID + "</EM>.")
wkline ("Your user information is:")
wkline ("Name: " + ALLTRIM (cFirstName) + ' ' + ;
 ALLTRIM (cMiddleName) + ' ' + ALLTRIM (cLastName))
wkline ("Thank you for registering at Benny's Clipper Web-O-Rama!")

return nil

