
/*

$Id: wklog.c,v 1.1 1997/09/26 01:47:52 catfood Exp $

WebKit: CGI and FastCGI interface library for FlagShip
Copyright (C) 1996,1997   Mark W. Schumann <webkit@underflap.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$Log: wklog.c,v $
Revision 1.1  1997/09/26 01:47:52  catfood
Initial revision


*/

#include <FSextend.h>
#include <stdio.h>
#include <syslog.h>

/*

	WKSETLOG (nFacility) --> NIL

		Initialize the syslog facility.

*/

FSudfname (wksetlog)
{
int aiFacility[] =
	{LOG_LOCAL0, LOG_LOCAL1, LOG_LOCAL2, LOG_LOCAL3,
	 LOG_LOCAL4, LOG_LOCAL5, LOG_LOCAL6, LOG_LOCAL7};
int iFacility;
int i;

	FSinit();
	if ((PCOUNT < 1) || !ISNUM (1))
	{
		iFacility = LOG_LOCAL0;
	}
	else
	{
		i = _parni (1);
		if (i < 0 || i > 7)
		{
			iFacility = LOG_LOCAL0;
		}
		else
		{
			iFacility = aiFacility[i];
		}
	}

	openlog ("webkit-cl", LOG_CONS | LOG_PID, iFacility);
	_ret();
	FSreturn;
}


FSudfname (wksyslog)
{
int iSeverity;
char *szValue;

	FSinit();
	if ((PCOUNT < 2) || !ISNUM (1) || !ISCHAR (2))
	{
		syslog (iSeverity, "invalid args to wksyslog()");
		FSreturn;
		/* goto bailout; */
	}

	iSeverity = _parni (1);
	szValue = (char *) _parc (2);
	syslog (iSeverity, szValue);
bailout:
	_ret();
	FSreturn;
}

