/* FlagShip calable function SLEEP(n)
 * (c) 1999 by multisoft GmbH
 * will be also available in the library of FlagShip rel. 4.5 or later
 */

#include "FSopenc.h"

/* ---------------------------------------------------------
 * SLEEP ([n]) -> NIL
 *
 * sleep n seconds. default = 1
 *
 * This function may also be used when IOCTL is diasabled
 * via FUNCT CursesInit, as opposite to INKEY() which 
 * require IOCTL
 * --------------------------------------------------------- */
UDF_DECL(sleep)
{
   int seconds = 1;

   if (IS_VAR_NUM(argv[0]))
      seconds = VAR_INTNUM(argv[0]);
   if (seconds <= 0)
      seconds = 1;
   sleep(seconds);
   return NIL_VAR;
}
