****************
* __dispfile(DIR,SKEL,PRINTER)
* 
* funcion definida para compatibilizar:
* hacia : DISPLAY FILES          Fox command
* desde : directory()            Clipper function
* parametros:
* DIR     => DIRECTORIO
* SKEL    => ESQUELETO
* PRINTER => .T.                 Direcciona a printer
*******************
#include "directry.fh"
func __dispfile(DIR,SKEL,PRINTER)
Local dirstru, Total:=0, Dbfmode:=.f.,Include, OldSelect
OldSelect:=select()
if PRINTER
   set device to printer
   set printer on
endif
if Empty(DIR)
   DIR  := './'
endif
if Empty(SKEL)
   SKEL := '*.dbf'
endif
if lower(right(SKEL,3)) == 'dbf'
   Dbfmode:=.t.
   Include:='A'
   Qout ('Database files    # Records  Last update  Size')
else
   Include:='HDA'
   Dbfmode:=.f.
endif
dirstru :=directory(DIR+SKEL,Include)
// print heading hear
//
// print list hear
do case
   case Dbfmode
        for i=1 to len(dirstru)
            select (0)
            dbusearea(.f.,,(dirstru[i,F_NAME]),(dirstru[i,F_NAME]),.f.)
            ?  padr(dirstru[i,F_NAME],15)
            ?? Lastrec()
            ?? space(3),dirstru[i,F_DATE ] 
            ?? dirstru[i,F_SIZE ]
            Total:=Total+dirstru[i,F_SIZE]
            use
        next
    otherwise
        for i=1 to len(dirstru) step 4
            ? padr(dirstru[i,F_NAME],15)
            Total:=Total+dirstru[i,F_SIZE]
            for j=1 to 3
                if (i+j) > len(dirstru)
                   exit
                endif
                ?? padr(dirstru[i+j,F_NAME],15)
                Total:=Total+dirstru[i+j,F_SIZE]
            next
        next
     endcase

//
// print footing hear
? ''
? Total
?? ' bytes in '
?? padl(i-1,6) 
?? ' files.'
? diskspace()
?? ' bytes remaining on current filesystem.'
if PRINTER
   set device to screen
   set printer to
endif
select(OldSelect)
return
** eof **

