       IDENTIFICATION DIVISION.
       PROGRAM-ID. ABMSAMPLE.
       AUTHOR. CARRILES.

       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT FRASAMPLE ASSIGN TO DISK FILE STATUS IS isam-status
              RECORD KEY IS ASAMPLE-KEY ACCESS MODE IS DYNAMIC
              ALTERNATE RECORD KEY IS ASAMPLE-ALT-KEY1
                WITH DUPLICATES
              ORGANIZATION IS INDEXED.


       DATA DIVISION.
       FILE SECTION.
           COPY FD.TXT.

       WORKING-STORAGE SECTION.
       77  I          PIC 99   VALUE 0.
       77  W7L-I      PIC ZZ.
       77  W7L-OP     PIC 9    VALUE 0.

      ***************************************************************
      * COPY CON LOS CAMPOS DE UTILIZACION PERMAMENTE EN LA WORKING *
      ***************************************************************
       77  W7A-COD   PIC 99 VALUE 0.
       77  C-RECOV   PIC 9  VALUE 1.
       77  W7A-RESP  PIC XX VALUE SPACES.
       77  W7A-RESP-1 PIC XX VALUE SPACES.
       77  W7A-LIN    PIC 99 VALUE 0.
       77  W7A-POS    PIC 99 VALUE 0.
       77  W7A-POS-1  PIC 99 VALUE 0.
       77  ISAM-STATUS PIC XX VALUE SPACES.
       77  ST-02      PIC XX VALUE SPACES.
       77  W7A-OBS    PIC X(70) VALUE SPACES.
       77  W7A-PRG    PIC X(10) VALUE SPACES.
       77  W7A-EMP    PIC X(30) VALUE SPACES.
       77  W7A-CON-LIN PIC 99  VALUE 80.
       77  W7A-PAGE    PIC 9(4) VALUE 1.
       77  W7A-PRIM    PIC 9   VALUE 1.
       77  W7A-FUNC    PIC 9   VALUE 1.
       77  W7A-C-ST    PIC XX VALUE SPACES.
       77  W7A-CLVA    PIC 9(4) VALUE 0.
       77  W7A-S15     PIC 9(15) VALUE 0.
       77  PRG         PIC 9    VALUE 1.
       77  STAT        PIC XX   VALUE SPACES.
       77  W7A-I-DD    PIC 99.
       77  W7A-I-MM    PIC 99.
       77  W7A-I-AA    PIC 99.
       77  W7A-C-DD    PIC 99.
       77  W7A-C-MM    PIC 99.
       77  W7A-C-AA    PIC 99.
       77  N-DECLARATIVA PIC X(13) VALUE SPACES.

       01  HP-DIA.
           03 HP-AA    PIC 99.
           03 HP-MM    PIC 99.
           03 HP-DD    PIC 99.

       01  HP-DIA1   PIC 9(6) REDEFINES HP-DIA.

       01  W1A-DIA.
           03 DD    PIC 99.
           03 MM    PIC 99.
           03 AA    PIC 99.

       01  W1A-DIA1   PIC 9(6) REDEFINES W1A-DIA.

       01  W1A-TIM.
           03 HH    PIC 99.
           03 MM-1  PIC 99.
           03 SS    PIC 99.

       01  W1A-TIM1   PIC 9(6) REDEFINES W1A-TIM.

      ******************* FIN COPY WRK001 *******************************

      ***************************************************************
      * COPY CON LOS CAMPOS DE UTILIZACION PERMANENTE EN LA WORKING *
      ***************************************************************
       01  W1A-TAB-1.
           03 FILLER PIC X(30)  VALUE "Add    Record".
           03 FILLER PIC X(30)  VALUE "Delete Record".
           03 FILLER PIC X(30)  VALUE "Modify Record".
           03 FILLER PIC X(30)  VALUE "View   Record"

       01  W1A-TAB  REDEFINES W1A-TAB-1.
           03 W1A-EL  PIC X(30) OCCURS 4 TIMES.

      *********************** FIN WRK002 ****************************


       SCREEN SECTION.

       01  SD1-OPCION-C LINE 20 COLUMN 10
              VALUE "Input Option :".

       01  SD1-PANT.
           02 LINE 7 COLUMN 2 HIGHLIGHT VALUE "Name        : ".
           02 SD2-DESC LINE 7 COLUMN 24
              PIC X(30) USING ASAMPLE-name.
           02 LINE 8 COLUMN 2 HIGHLIGHT VALUE "Address     : ". 
           02 SD2-DIR LINE 8 COLUMN 24
              PIC X(30) USING ASAMPLE-address.
           02 LINE 9 COLUMN 2 HIGHLIGHT VALUE "Zip-code    : ".
           02 SD2-LOC LINE 9 COLUMN 24
              PIC z(6) USING ASAMPLE-zip.
           02 LINE 10 COLUMN 2 HIGHLIGHT VALUE "Stock       : ". 
           02 SD2-POST LINE 10  COLUMN 24
              PIC Z(4).zz  USING ASAMPLE-STOCK. 
          
       01  SA1-ENT.
           02 SA2-CL LINE 5 COLUMN 24
              PIC 99999 USING ASAMPLE-CODe AUTO.


       01  SD1-CRT.
           03 BLANK SCREEN.
           03 BELL.
           03 SD2-EMP LINE 1 COLUMN 1 
              PIC X(30) USING W7A-EMP.
           03 LINE 1 COLUMN 60 
                 VALUE "abmsample by O.C.    ".
           03 LINE 2 COLUMN 60 
                 VALUE "DEMO   ".
           03 LINE 2 COLUMN 73
              PIC ZZ USING DD.
           03 LINE 2 COLUMN 75 VALUE "/".
           03 LINE 2 COLUMN 76
              PIC ZZ USING MM. 
           03 LINE 2 COLUMN 78 VALUE "/".
           03 LINE 2 COLUMN 79
              PIC ZZ USING AA.
           03 LINE 2 COLUMN 1 HIGHLIGHT  
              PIC X(30) USING W7A-OBS.
           03 LINE 3 COLUMN 1 VALUE
              "---------------------------------------------------------
      -       "-----------------------".
           03 LINE 21 COLUMN 1 VALUE
              "---------------------------------------------------------
      -       "-----------------------".
           03 LINE 23 COLUMN 1 Highlight VALUE
              "<Enter/f2> Confirm    <f10> Go Back    <f1> Options       
      -       "      <f8> Main Menu   ".

      *****************************************************************
      *   CAMPOS DE DISPLAY Y ACCEPT UTILIZABLES TODOS LOS PROGRAMAS  *
      *****************************************************************
       01  SA1-OPCION.
           02 SA2-OPCION  LINE 20 COLUMN 50 PIC 99 TO W7A-COD.

       01  SD1-N-EST.
           03 LINE 22 COLUMN 1 BLINK
              highlight
              VALUE "Record not found ...... <Enter>".

       01  SA1-N-EST LINE 22 COLUMN 50 BELL PIC XX TO W7A-RESP.

       01  SD1-CONF.
           03 LINE 22 COLUMN 1 highlight VALUE "Is it correct?".

       01  SA1-CONF.
           03 LINE 22 COLUMN 50 
               PIC XX USING W7A-RESP-1.

       01  SD1-ESP.
           03 LINE 22 COLUMN 1 BELL REVERSE-VIDEO
              VALUE "Wait a minute please .......".

       01  SD1-ERROR-FATAL.
           03 blank screen.
           03 line 1 column 10 value
              "*******************************************************".
           03 line 2 column 10 value
              "*  A FATAL ERROR OCCURS IN THE LAST I-O  OPERATION    *".
           03 line 3 column 10 value
              "*         PROCESS    IS       OVER                    *".
           03 line 5 column 10 value
              "*-----------------------------------------------------*".
           03 line 6 column 10 value
              "* FILE   : ".
           03 LINE 6 COLUMN 26
              PIC X(13) USING N-DECLARATIVA.
           03 line 6 column 64 value
              "*".
           03 line 7 column 10 value
              "*  STATUS : ".
           03 LINE 7 COLUMN 26
              PIC XX USING STAT.
           03 line 7 column 64 value
              "*".
           03 line 8 column 10 value
              "*******************************************************".
           03 line 21 column 10 value
              "<Enter> to continue .....".

       01  SD1-ERROR.
           03 bell.
           03 line 24 column 1 value
              "*** INVALID OPERATION  ***".
           03 line 24 column 28 value
              "File   :".
           03 line 24 column 36
              pic x(13) using n-declarativa.
           03 line 24 column 51 value
              "Status:".
           03 line 24 column 58
              pic xx using stat.
           03 line 24 column 62 value
              "<Enter...>".

      ****************** FIN SCR.CPY ********************************

       PROCEDURE DIVISION.
       R010-AP.
      *    OPEN OUTPUT FRASAMPLE.
           OPEN I-O FRASAMPLE.
           MOVE 2 TO W7A-FUNC. ACCEPT HP-DIA FROM DATE.
           MOVE HP-DD  TO DD. MOVE HP-MM  TO MM.
           MOVE HP-AA  TO AA.

       R020-PROC. PERFORM R1SAMPLE-OP   THRU R130-F-OP.
           IF W7A-COD = 1
              PERFORM R2SAMPLE-ALTA THRU R420-F-ALTA
              GO TO R020-PROC.
           IF W7A-COD = 2
              PERFORM R7SAMPLE-BAJA THRU R770-F-BAJA
              GO TO R020-PROC.
           IF W7A-COD = 3
              PERFORM R8SAMPLE-MOD THRU R990-F-MOD
              GO TO R020-PROC.
           IF W7A-COD = 4
              PERFORM R12SAMPLE-CONS  THRU R1210-F-CONS
              GO TO R020-PROC.
           MOVE "Option not found              " TO W7A-OBS.
           DISPLAY SD1-ERROR.  ACCEPT (20, 70) W7A-RESP.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
           IF W7A-C-ST = "09" GO TO R050-FINAL.
           GO TO R050-FINAL.

       R050-FINAL. CLOSE FRASAMPLE. 
           STOP RUN.

       R1SAMPLE-OP.
           MOVE "SAMPLE  " TO W7A-OBS.
           DISPLAY SD1-CRT.
           MOVE 1 TO I. MOVE 5 TO W7A-LIN.

       R110-DIP-OP. IF I > 4 GO TO R120-AC.
           MOVE W7A-LIN TO LIN. MOVE I TO W7L-I.
           DISPLAY (LIN, 10) W7L-I.
           DISPLAY (LIN, 15) W1A-EL (I).
           ADD 1 TO I. ADD 2 TO W7A-LIN.
           GO TO R110-DIP-OP.

       R120-AC. 
           DISPLAY SD1-OPCION-C.
           ACCEPT SA1-OPCION.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
           IF W7A-C-ST = "11" GO TO R120-AC.
           IF W7A-C-ST = "09" GO TO R050-FINAL.
           IF W7A-COD = 99 GO TO R050-FINAL.
           IF (W7A-COD < 1 OR W7A-COD > 4) GO TO R120-AC.

       R130-F-OP. EXIT.

       R2SAMPLE-ALTA.
           PERFORM R5SAMPLE-DISP THRU R530-F-DISP.
           IF W7A-C-ST = "02" GO TO R420-F-ALTA.
           PERFORM R6SAMPLE-L-STOCK THRU R660-F-L-STOCK.
           IF ISAM-STATUS = SPACES OR ISAM-STATUS = "00"
	     DISPLAY (24, 1) "Record already added"
             ACCEPT (24, 50) W7A-RESP
             GO TO R420-F-ALTA.
           GO TO R210-DESC.

       R210-DESC. ACCEPT SD2-DESC.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
           IF W7A-C-ST = "11" GO TO R2SAMPLE-ALTA.
           IF W7A-C-ST = "02" GO TO R420-F-ALTA.
	   IF W7A-C-ST = "09" GO TO R050-FINAL.

       R230-DIR. ACCEPT SD2-DIR.
	   ACCEPT W7A-C-ST FROM ESCAPE KEY.
	   IF W7A-C-ST = "11" GO TO R210-DESC.
	   IF W7A-C-ST = "02" GO TO R420-F-ALTA.
	   IF W7A-C-ST = "09" GO TO R050-FINAL.

       R240-LOC. ACCEPT SD2-LOC.
	   ACCEPT W7A-C-ST FROM ESCAPE KEY.
	   IF W7A-C-ST = "11" GO TO R230-DIR.
	   IF W7A-C-ST = "02" GO TO R420-F-ALTA.
	   IF W7A-C-ST = "09" GO TO R050-FINAL.

       R250-POST. ACCEPT SD2-POST.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
	   IF W7A-C-ST = "11" GO TO R240-LOC.
           IF W7A-C-ST = "02" GO TO R420-F-ALTA.
           IF W7A-C-ST = "09" GO TO R050-FINAL.

       R4SAMPLE-CNF. DISPLAY SD1-CONF. ACCEPT SA1-CONF.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
           IF W7A-C-ST = "02" GO TO R420-F-ALTA.
           IF W7A-C-ST = "09" GO TO R050-FINAL.
           IF W7A-RESP-1 NOT = "N" AND W7A-RESP-1 NOT = "Y" AND
              W7A-RESP-1 NOT = "NO" AND W7A-RESP-1 NOT = "YE"
              GO TO R4SAMPLE-CNF.
           IF W7A-RESP-1 NOT = "Y" AND W7A-RESP-1 NOT = "YE"
              GO TO R2SAMPLE-ALTA.

       R410-GR.
           WRITE RASAMPLE INVALID
             MOVE ISAM-STATUS TO STAT
             DISPLAY SD1-ERROR
             ACCEPT (24, 50) W7A-RESP.
              
       R420-F-ALTA. EXIT.

       R5SAMPLE-DISP. MOVE W1A-EL (W7A-COD) TO W7A-OBS.
           MOVE 0 TO ASAMPLE-Code.
           DISPLAY SD1-CRT.
           DISPLAY (5, 2) "Code  : ".
           ACCEPT SA2-CL.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
           IF W7A-C-ST = "11" GO TO R5SAMPLE-DISP.
           IF W7A-C-ST = "02" GO TO R530-F-DISP.
           IF W7A-C-ST = "09" GO TO R050-FINAL.

       R530-F-DISP. EXIT.

       R6SAMPLE-L-STOCK. READ FRASAMPLE INVALID
              MOVE 0 TO ASAMPLE-STOCK ASAMPLE-ZIP
              MOVE SPACES TO ASAMPLE-NAME ASAMPLE-ADDRESS.

       R610-L-IND. 

       R650-DISP.
           DISPLAY SD1-PANT. 

       R660-F-L-STOCK. EXIT.

       R7SAMPLE-BAJA.
           PERFORM R5SAMPLE-DISP THRU R530-F-DISP.
           IF W7A-C-ST = "02" GO TO R770-F-BAJA.
           PERFORM R6SAMPLE-L-STOCK THRU R660-F-L-STOCK.
           IF ISAM-STATUS > "19" AND ISAM-STATUS < "30"
              DISPLAY SD1-N-EST ACCEPT SA1-N-EST
              GO TO R770-F-BAJA.

       R730-CONF. MOVE SPACES TO W7A-RESP-1.
           DISPLAY SD1-CONF. ACCEPT SA1-CONF.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
           IF W7A-C-ST = "02" GO TO R770-F-BAJA.
           IF W7A-C-ST = "09" GO TO R050-FINAL.
           IF W7A-C-ST = "11" GO TO R7SAMPLE-BAJA.
           IF W7A-RESP-1 NOT = "Y" AND W7A-RESP-1 NOT = "N" AND
              W7A-RESP-1 NOT = "YE" AND W7A-RESP-1 NOT = "NO"
              GO TO R730-CONF.
           IF W7A-RESP-1 = "N" OR W7A-RESP-1 = "NO"
              GO TO R770-F-BAJA.

       R760-DEL. DELETE FRASAMPLE INVALID
             MOVE ISAM-STATUS TO STAT
             DISPLAY SD1-ERROR
             DISPLAY (10, 60) ASAMPLE-CODE
             ACCEPT W7A-RESP GO TO R050-FINAL.

       R770-F-BAJA. EXIT.

       R8SAMPLE-MOD.
           PERFORM R5SAMPLE-DISP  THRU R530-F-DISP.
           IF W7A-C-ST = "02" GO TO R990-F-MOD.
           PERFORM R6SAMPLE-L-STOCK THRU R660-F-L-STOCK.
           IF ISAM-STATUS NOT = "SAMPLE" AND ISAM-STATUS NOT = "  "
              DISPLAY SD1-N-EST ACCEPT SA1-N-EST
              GO TO R990-F-MOD.

       R810-DEN. ACCEPT SD2-DESC.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
           IF W7A-C-ST = "11" 
              DISPLAY SD2-DESC GO TO R820-DIR.
           IF W7A-C-ST = "02" GO TO R990-F-MOD.
           IF W7A-C-ST = "09" GO TO R050-FINAL.

       R820-DIR. ACCEPT SD2-DIR.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
           IF W7A-C-ST = "11"
              DISPLAY SD2-DIR GO TO R830-LOC.
           IF W7A-C-ST = "02" GO TO R990-F-MOD.
           IF W7A-C-ST = "09" GO TO R050-FINAL.

       R830-LOC. ACCEPT SD2-LOC.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
           IF W7A-C-ST = "11" 
              DISPLAY SD2-LOC GO TO R840-POST.
           IF W7A-C-ST = "02" GO TO R990-F-MOD.
           IF W7A-C-ST = "09" GO TO R050-FINAL.

       R840-POST. ACCEPT SD2-POST.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
           IF W7A-C-ST = "11"
              DISPLAY SD2-POST GO TO R830-LOC.
           IF W7A-C-ST = "02" GO TO R990-F-MOD.
           IF W7A-C-ST = "09" GO TO R050-FINAL.


       R970-CNF.
           DISPLAY SD1-CONF. ACCEPT SA1-CONF.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
           IF W7A-C-ST = "02" GO TO R990-F-MOD.
           IF W7A-C-ST = "09" GO TO R050-FINAL.
           IF W7A-C-ST = "11" GO TO R810-DEN.
           IF W7A-RESP-1 NOT = "N" AND W7A-RESP-1 NOT = "Y" AND
              W7A-RESP-1 NOT = "NO" AND W7A-RESP-1 NOT = "YE" 
              GO TO R970-CNF.
           IF W7A-RESP-1 = "N" OR W7A-RESP-1 = "NO" GO TO R8SAMPLE-MOD.

       R980-GRB. REWRITE RASAMPLE INVALID
              MOVE ISAM-STATUS TO STAT
              DISPLAY SD1-ERROR
              ACCEPT (24, 50) W7A-RESP GO TO R050-FINAL.

       R990-F-MOD. EXIT.
     

       R12SAMPLE-CONS. PERFORM R5SAMPLE-DISP THRU R530-F-DISP.
           PERFORM R6SAMPLE-L-STOCK THRU R660-F-L-STOCK.
           IF ISAM-STATUS > "19" AND ISAM-STATUS < "30"
              DISPLAY SD1-N-EST ACCEPT SA1-N-EST
              GO TO R1210-F-CONS.
           DISPLAY SD1-PANT.
           DISPLAY (22, 10) "Read is over       ? ".
           ACCEPT (22, 32) W7A-RESP.
           ACCEPT W7A-C-ST FROM ESCAPE KEY.
           IF W7A-C-ST = "02" GO TO R1210-F-CONS.
           IF W7A-C-ST = "09" GO TO R050-FINAL.
           IF W7A-C-ST = "11" GO TO R12SAMPLE-CONS.
           IF W7A-RESP = "NO" OR W7A-RESP = "N"
              GO TO R12SAMPLE-CONS.

       R1210-F-CONS. EXIT.


