** sample2.prg

extern MsCobNEW
Local Archivo:="SAMPLE.DAT"
Local i:=0, Ordd
sele 1
use &archivo EXCLUSIVE READONLY via MsCob
if !used()
   ? "Cannot open MsCob file SAMPLE.DAT, check permissions ..."
   quit
endif

// Create Xbase .dbf from Cobol ISAM structure

aStru := dbstruct()
? "Creating sample2.dbf from the Cobol structure:"
aeval(aStru, {|x| qout(x[1], x[2], x[3], x[4], if(len(x) > 4, x[5],""))})
if len(aStru[1]) > 4  // this RDD consist of FIVE elements instd. of 4
   aaStru := {}
   for ii := 1 to len(aStru)
      aadd (aaStru, {substr(aStru[ii,1],1,10), aStru[ii,2], ;
                     aStru[ii,3], aStru[ii,4]})
   next
else
   aaStru := aStru
endif
dbcreate ("sample2", aaStru)

// Transfer the ISAM database records to .dbf

select 2
use sample2
select 1
go top
while !eof()
   aField := FieldGetArr()
   (2)->(dbAppend())
   (2)->(FieldPutArr(aField))
   * for ii := 1 to fcount()                      // alternative
   *    (2)->(fieldput(ii, (1)->(fieldget(ii))))  // alternative
   * next                                         // alternative
   skip
enddo

// display the results

select 2
? "--> Database sample2.dbf in natural order (first 3 fields)"
* list                                            // alternative for all
list &(fieldname(1)), &(fieldname(2)), &(fieldname(3))
wait
? "--> Database sample2.dbf sorted on " + fieldname(2)
index on &(fieldname(2)) to sample2
list &(fieldname(1)), &(fieldname(2)), &(fieldname(3))
use

* eof
*** Compile: FlagShip sample2.prg -L. -lmscrdd -osample2

