
#ifndef __WEBKIT_GATEWAY_H
#define __WEBKIT_GATEWAY_H

/*

	_webkit.h
	$Id: _webkit.h,v 1.1 1997/09/26 01:47:52 catfood Exp $

	Private header for WebKit library.

	History:
	$Log: _webkit.h,v $
	Revision 1.1  1997/09/26 01:47:52  catfood
	Initial revision


*/

#include <pwd.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <sys/syslog.h>

#define HOSTNAME_BUFFER_SIZE 1024
#define SERVER_BACKLOG 10
#define WELL_KNOWN_PORT 1234

/* #define TIMER_FEATURE */
#define GATEWAY_FEATURE

#define COPY_GULP 1024

#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))

#define FSFUNC(x) variable *_bb_##x (int, variable **);

/* This is GCC-specific with usage of __PRETTY_FUNCTION__ */
#define MARK \
 syslog (LOG_DEBUG, "Reached line %d in %s", __LINE__, __PRETTY_FUNCTION__);

/* Porting gotcha's */
#ifdef __linux__
typedef unsigned long HOST_ADDRESS;
/* #else */
/* #error Your platform is not yet supported by WebKit */
#endif

#ifdef FlagShip
variable *_bb_wkserver_shim (int socket,
 const char *envblock,  int envcount,  int envlen,
 const char *formblock, int formcount, int formlen);
#endif

int writen (const char *);
int writenl (const char *);
void exitproc (void);

#endif

