/*

DATABASE LOOKUP

$Id: example3.prg,v 1.1 1997/09/26 01:47:52 catfood Exp $

WebKit: CGI and FastCGI interface library for FlagShip
Copyright (C) 1996,1997   Mark W. Schumann <webkit@underflap.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$Log: example3.prg,v $
Revision 1.1  1997/09/26 01:47:52  catfood
Initial revision


*/

function example3 (aEnv, aForm)
local i as numeric
local a as array

wkhtml()
wkbody()
balance (wklookup (aEnv, "ACCOUNT"))
wkbodyend()
wkhtmlend()
return nil

static function balance (cAccount)
field firstname in user
field middlename in user
field lastname in user
field userid in user
field balance in user
local cUserName
local nBalance

use user index user1
cAccount := padl (alltrim (cAccount), len (user->userid))

if dbseek (cAccount, .F.)

	cUserName := ;
	 ALLTRIM (user->firstname) + ' ' + ;
	 ALLTRIM (user->middlename) + ' ' + ;
	 ALLTRIM (user->lastname)

	nBalance := user->balance

	wkline (cUserName, ;
	 "your balance is $" + ALLTRIM (STR (nBalance, 7, 2)))

else

	// Your program can output
	//  a URL reference that leads to another form,
	//  or even another instance of the same program.
	? "Sorry, your account is not in our database...yet!  "
	? "But as long as you're here, why not "
	wklink ("#example2", "register")
	? " to take advantage of these <EM>great</EM> offers?"
endif
close

return nil
