
/*

EXAMPLE TABLE BROWSER

$Id: example6.prg,v 1.2 1997/09/30 04:45:38 catfood Exp catfood $

WebKit: CGI and FastCGI interface library for FlagShip
Copyright (C) 1996,1997   Mark W. Schumann <webkit@underflap.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$Log: example6.prg,v $
Revision 1.2  1997/09/30 04:45:38  catfood
Multiple fixes to bring us to WK release 1.02.

Revision 1.1  1997/09/26 01:47:52  catfood
Initial revision


*/

static function ntrim (n as numeric) as string
return alltrim (str (n))

static function asstring (x as usual) as string
local cType as string
local cString as string

cType := valtype (x)
do case
case cType == "C"
	cString := x
case cType == "N"
	cString := nTrim (x)
case cType == "L"
	cString := iif (x, "y", "n")
case cType == "D"
	cString := dtoc (x)
otherwise
	cString := "[type " + cType + "?]"
endcase
return cString

function example6 (aEnv, aForm)

wkhtml()
wkbody()
use user shared readonly
? "<table>"
? "<caption>Example table-browser output</caption>"
for i := 1 to fcount()
	? "<th>" + fieldname (i) + "</th>"
next
do while !eof()
	? "<tr>"
	for i := 1 to fcount()
		? "<td>" + alltrim (asstring (fieldget (i))) + "</td>"
	next
	? "</tr>"
	skip
end
close
? "<tr>END OF DATA</tr>"
? "</table>"
wkbodyend()
wkhtmlend()
return nil

