/*

WebKit: CGI and FastCGI interface library for FlagShip
Copyright (C) 1996,1997   Mark W. Schumann <webkit@underflap.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

class wkstate
protect aData as array
export state as numeric

method init class wkstate
aData := {}
state := 0
return self

method noivarput (cIvar, xValue) class wkstate
aadd (aData, { alltrim (lower (cIvar)), xValue })
return xValue

method noivarget (cIvar) class wkstate
local n as numeric

cIvar := alltrim (lower (cIvar))
n := ascan (aData, {|z| z[1] == cIvar})
if n > 0
	return aData[n][1]
else
	return nil
endif

